package com.banesco.module.payment_request.infrastructure.client;

import com.banesco.common.application.helper.SerializationHelper;
import com.banesco.common.application.usecase.HttpClientUseCase;
import com.banesco.common.domain.exception.HttpStatusCodeException;
import com.banesco.common.domain.exception.ApiPrivateException;
import com.banesco.common.domain.model.*;
import com.banesco.common.infrastructure.config.RestClientConfig;
import com.banesco.module.payment_request.application.usecase.PaymentRequestUseCase;
import com.banesco.module.payment_request.domain.dto.request.PaymentRequestRequest;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import lombok.extern.slf4j.Slf4j;

import java.util.List;
import java.util.Map;

@Slf4j
@ApplicationScoped
public class PaymentRequestClient implements PaymentRequestUseCase {
    private final SerializationHelper serializationHelper;
    private final HttpClientUseCase httpClientUseCase;
    private final PaymentRequestConfig paymentRequestConfig;

    private static final String EMPTY_MESSAGE = "EMPTY_MESSAGE";

    @Inject
    public PaymentRequestClient(
        SerializationHelper serializationHelper,
        HttpClientUseCase httpClientUseCase,
        RestClientConfig restClientConfig
    ) {
        this.serializationHelper = serializationHelper;
        this.httpClientUseCase = httpClientUseCase;
        this.paymentRequestConfig = restClientConfig.getPaymentRequestConfig();
        log.info("Configuracion cargada para payment-request: {}", paymentRequestConfig);
    }

    @Override
    public <T> List<T> execute(
        PaymentRequestRequest params,
        Class<T> responseType
    ) {
        String fintechId = params.getFintechId();
        String receiverId = params.getGlobal().getIdentificacionDestino();
        Map<String, Object> payload = getPayload(params);
        HttpRequest request = HttpRequest.forApiPrivateResponseList(
                paymentRequestConfig.getUrl(),
                paymentRequestConfig.getStatusSuccess(),
                HttpRequest.HttpMethod.POST,
                responseType
            )
            .withBody(payload)
            .withHeaders(Map.of("fintechId", fintechId))
            .withTimeout(
                paymentRequestConfig.getTimeout().getConnect(),
                paymentRequestConfig.getTimeout().getResponse()
            );

        try {
            ApiPrivateResponse<Either<List<T>, ApiPrivateError>> response =
                httpClientUseCase.executeApiPrivateResponseList(request);
            Either<List<T>, ApiPrivateError> detail = response.getDetalle();

            if(detail == null) {
                log.error(
                    "API retorno exitoso pero con detalle vacio. Codigo: {}, Mensaje: {}",
                    response.getEstatus(),
                    response.getMensaje()
                );

                throw ApiPrivateException.builder()
                    .statusCode("PIBE-00")
                    .message(EMPTY_MESSAGE)
                    .build();
            }

            if (detail.isLeft()) {
                if(detail.getLeft() == null) {
                    throw ApiPrivateException.builder()
                        .statusCode("PIBE-00")
                        .message(EMPTY_MESSAGE)
                        .build();
                }
                
                return detail.getLeft();
            }

            ApiPrivateError error = detail.getRight();

            log.error(
                "API privada retorno error. Codigo: {}, Mensaje: {}, Error Interno: {} -> {}",
                response.getEstatus(),
                response.getMensaje(),
                error.getCodError(),
                error.getMensajeError()
            );

            throw ApiPrivateException.builder()
                .statusCode("PIBE-01")
                .message((error.getCodError() != null)
                    ? error.getCodError() + ":" + error.getMensajeError()
                    : EMPTY_MESSAGE
                )
                .build();
        } catch (ApiPrivateException e) {
            throw e;
        } catch (HttpStatusCodeException e) {
            log.error(
                "Error HTTP reportando del cliente {}: {} - {}",
                receiverId,
                e.getStatusCode(),
                e.getMessage()
            );
            throw e;
        } catch (Exception e) {
            log.error("Error reportando del cliente {}: {}", receiverId, e.getMessage());
            throw HttpStatusCodeException.serviceUnavailable("503");
        }
    }

    private Map<String, Object> getPayload(PaymentRequestRequest params) {
        Map<String, Object> paymentRequestRequest = serializationHelper.toMap(params);
        Map<String, Object> global = serializationHelper.toTreeMap(params.getGlobal());
        List<Map<String, Object>> requests = params
            .getSolicitudes()
            .stream()
            .map(serializationHelper::toTreeMap)
            .toList();
        String signature = serializationHelper.generateSignature(
            global, requests, params.getCanalOrigen()
        );

        paymentRequestRequest.put("firma", signature);
        paymentRequestRequest.put("global", global);
        paymentRequestRequest.put("solicitudes", requests);

        paymentRequestRequest.remove("fintechId");

        log.info("3. Firma generada: {}", signature);
        log.info("4. Parametros de la solicitud: {}", paymentRequestRequest);
        log.info("5. Solicitud final: {}", paymentRequestRequest);

        return paymentRequestRequest;
    }
}